#!/usr/bin/python

from sys import *
from string import *
import os
import math

out = open("chip_cluster_fb.dat","a")
#out = open("report/chip_cluster_fb_0.3.dat","w")
testval = [0.001, 0.01, 0.02, 0.06, 0.1, 0.2, 0.4,   1.0,  1.5,   2.0,   3.0 ] 
testval = [0.15, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.3, 1.5]
for i in range(0,len(testval)):
	step = float(i)*0.1
	step = testval[i]

	#if i!=2: continue
	TP=TN=FP=FN=0
	for j in range(5):
		trainfile = "data/seq.fa_t"+str(j)
		testfile  = "data/seq.fa_" +str(j)
		tc = "s_"+chr(ord('a')+j)
		cmd = "./final_chip.py " + trainfile+ " "+tc+" "+str(step)
		print cmd
		os.system(cmd)
		cmd = "cat "+trainfile+" | ~/trainanhmm tmp/NC"+tc+str(i)+" -modelfile NChip.mod  -f "+tc+".ann -annotation "+tc+".gff -labels > /dev/null"
		print cmd
		os.system(cmd)
		cmd = "cat "+testfile+" | ~/decodeanhmm tmp/NC"+tc+str(i)+".mod -fb -pl -ps > "+tc+".dat"
		print cmd
		os.system(cmd)
		
		cmd = "./EvalHMMChip.py "+tc+".dat"
		r = os.popen(cmd)
		resulta = r.read()
		print resulta
    
		rlt = resulta.split("\n")
		for line in range(len(rlt)):
			a_result = rlt[line].split()
			if len(a_result)>0: 
				if a_result[0].find("TP")>=0:
					TP+=int(a_result[1])
					TN+=int(a_result[3])
					FP+=int(a_result[5])
					FN+=int(a_result[7])
					print TP, TN, FP, FN,"========="
    

	cc = ((TP*TN)-(FP*FN))/math.sqrt( (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN)   )
	print TP,TN,FP,FN, cc
	out.write(str(step)+"\t"+str(cc)+"\t")
	out.write("Sens: "+str(float(TP)/float(TP+FN))+ " Spec: "+str(float(TN)/float(TN+FP))+"\n")
    
out.close()

