#!/usr/bin/python

from sys import *
from string import *
import os
import math

testdist=[500, 1000, 2000, 3000, 4000, 5000, 10000,20000]
for h in range(len(testdist)):
	testdistfile="report/his_H"+str(testdist[h])+".dat"
	print testdistfile
	out = open(testdistfile,"w")
	testval = [0.15, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1.0, 1.3, 1.5]
	for i in range(len(testval)):
		step = float(i)*0.1
		step=testval[i]
		TP=TN=FP=FN=0
		promoter=enhancer=0
		for j in range(5):
			trainfile = "data/seq.fa_t"+str(j)
			testfile  = "data/seq.fa_" +str(j)
			tc = "s"+chr(ord('a')+j)
			cmd = "./final_chip.py " + trainfile+ " "+tc+" "+str(step)
			#os.system(cmd)
			cmd = "cat "+testfile+" | ~/decodeanhmm tmp/NC"+tc+str(i)+".mod -fb -pl -ps > "+tc+".dat"
			print cmd
			os.system(cmd)
		
			j=testdist[h]
			print "dist",j
			cmd = "./EvalHistone.py "+tc+".dat "+str(j)
			r1 = os.popen(cmd)
			resulta = r1.read()
	

			rlt = resulta.split("\n")
			for line in range(len(rlt)):
				a_result = rlt[line].split()
				#print a_result
				if len(a_result)>0: 
					if a_result[0].find("TP")>=0:
						TP+=int(a_result[1])
						TN+=int(a_result[3])
						FP+=int(a_result[5])
						FN+=int(a_result[7])
					if a_result[0].find("promoter")>=0:
						promoter+=int(a_result[1])
						enhancer+=int(a_result[3])
				#print	TP, TN, FP, FN 
		    
    
	 
		cc = ((TP*TN)-(FP*FN))/math.sqrt( (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN)   )
		print TP,TN,FP,FN, cc
    
		out.write(str(j)+"\t"+str(cc)+"\t")
		out.write("Sens: "+str(float(TP)/float(TP+FN))+ " Spec: "+str(float(TN)/float(TN+FP))+" pro "+str(promoter)+" enh "+str(enhancer)+" "+str(TP)+" "+str(TN)+" "+str(FP)+" "+str(FN)+"\n")
	
    #out.write(resulta)
    #out.write(resultb)
	out.close()

